> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.propexo.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.propexo.com/_mcp/server.

# Create Unit: Propertyware

POST https://api.propexo.com/v1/units/propertyware/
Content-Type: application/json

Create Unit: Propertyware| Method     |
| ---------- |
| createUnit |Due to PMS limitations, the ID of the created record cannot be retrieved. This will be found on the next data sync.

Reference: https://docs.propexo.com/api-reference/propertyware-soap/units/create-unit-propertyware

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://api.propexo.com` (Production, default)
- `https://api.sandbox.propexo.com` (Sandbox)

## Request

### Body (application/json)

This endpoint expects a _v1_units_propertyware__post_input.

- `integration_id` (string, required) — The Propexo unique identifier for the integration
- `property_id` (string, required) — The Propexo unique identifier for the property
- `category` (enum, required) — The category of the unit.
  - Allowed values: `Residential`, `Commercial`
- `type` (enum, required) — The type of the unit.
  - Allowed values: `Apartment`, `House`
- `name` (string, required) — The name of the unit. Example: "Unit 3".
- `abbreviation` (string, required) — The abbreviation of the unit. Example: "UNIT3"
- `address_1` (string, required) — The first address line of the unit.
- `address_2` (string, optional) — The second address line of the unit.
- `city` (string, optional) — The city of the unit.
- `state` (string, optional) — The state of the unit.
- `zip` (string, optional) — The zip code of the unit.
- `country` (string, optional) — The country of the unit.
- `notes` (string, optional) — Notes about the unit.
- `bathrooms` (string, optional, nullable) — The number of bathrooms in the unit.
- `bedrooms` (string, optional, nullable) — The number of bedrooms in the unit.
- `rent_amount_market_in_cents` (double, optional) — The market rent cost of the unit, in cents.
- `square_feet` (double, optional) — The size of the unit in square feet.

## Response

### 200

Successful response

- `meta` (V1UnitsPropertywarePostOutputMeta, required)
- `result` (V1UnitsPropertywarePostOutputResult, required)

## Errors

### 400 Bad Request Error

Bad Request

- `error` (ErrorResponseError, required)

## Types

### V1UnitsPropertywarePostOutputMeta

- `job_id` (string, required)

### V1UnitsPropertywarePostOutputResult

- `integration_id` (string, required) — The Propexo unique identifier for the integration
- `property_id` (string, required) — The Propexo unique identifier for the property
- `category` (enum, required) — The category of the unit.
  - Allowed values: `Residential`, `Commercial`
- `type` (enum, required) — The type of the unit.
  - Allowed values: `Apartment`, `House`
- `name` (string, required) — The name of the unit. Example: "Unit 3".
- `abbreviation` (string, required) — The abbreviation of the unit. Example: "UNIT3"
- `address_1` (string, required) — The first address line of the unit.
- `address_2` (string, required, nullable) — The second address line of the unit.
- `city` (string, required, nullable) — The city of the unit.
- `state` (string, required, nullable) — The state of the unit.
- `zip` (string, required, nullable) — The zip code of the unit.
- `country` (string, required, nullable) — The country of the unit.
- `notes` (string, required, nullable) — Notes about the unit.
- `rent_amount_market_in_cents` (double, required, nullable) — The market rent cost of the unit, in cents.
- `square_feet` (double, required, nullable) — The size of the unit in square feet.
- `bathrooms` (string, optional, nullable) — The number of bathrooms in the unit.
- `bedrooms` (string, optional, nullable) — The number of bedrooms in the unit.

### ErrorResponseError

- `code` (string, required)
- `message` (string, required)
- `details` (map from string to any, optional)

## Examples

**Request**

```json
{
  "integration_id": "intg-987654321",
  "property_id": "prop-123456789",
  "category": "Residential",
  "type": "Apartment",
  "name": "Unit 12B",
  "abbreviation": "U12B",
  "address_1": "456 Elm Street"
}
```

**Response**

```json
{
  "meta": {
    "job_id": "job-20240615-001"
  },
  "result": {
    "integration_id": "intg-987654321",
    "property_id": "prop-123456789",
    "category": "Residential",
    "type": "Apartment",
    "name": "Unit 12B",
    "abbreviation": "U12B",
    "address_1": "456 Elm Street",
    "address_2": "Apt 12B",
    "city": "Springfield",
    "state": "IL",
    "zip": "62704",
    "country": "USA",
    "notes": "Recently renovated kitchen and bathroom.",
    "rent_amount_market_in_cents": 125000,
    "square_feet": 1200,
    "bathrooms": "2",
    "bedrooms": "3"
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.propexo.com/v1/units/propertyware/"

payload = {
    "integration_id": "intg-987654321",
    "property_id": "prop-123456789",
    "category": "Residential",
    "type": "Apartment",
    "name": "Unit 12B",
    "abbreviation": "U12B",
    "address_1": "456 Elm Street"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.propexo.com/v1/units/propertyware/';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"integration_id":"intg-987654321","property_id":"prop-123456789","category":"Residential","type":"Apartment","name":"Unit 12B","abbreviation":"U12B","address_1":"456 Elm Street"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.propexo.com/v1/units/propertyware/"

	payload := strings.NewReader("{\n  \"integration_id\": \"intg-987654321\",\n  \"property_id\": \"prop-123456789\",\n  \"category\": \"Residential\",\n  \"type\": \"Apartment\",\n  \"name\": \"Unit 12B\",\n  \"abbreviation\": \"U12B\",\n  \"address_1\": \"456 Elm Street\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.propexo.com/v1/units/propertyware/")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"integration_id\": \"intg-987654321\",\n  \"property_id\": \"prop-123456789\",\n  \"category\": \"Residential\",\n  \"type\": \"Apartment\",\n  \"name\": \"Unit 12B\",\n  \"abbreviation\": \"U12B\",\n  \"address_1\": \"456 Elm Street\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.propexo.com/v1/units/propertyware/")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"integration_id\": \"intg-987654321\",\n  \"property_id\": \"prop-123456789\",\n  \"category\": \"Residential\",\n  \"type\": \"Apartment\",\n  \"name\": \"Unit 12B\",\n  \"abbreviation\": \"U12B\",\n  \"address_1\": \"456 Elm Street\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.propexo.com/v1/units/propertyware/', [
  'body' => '{
  "integration_id": "intg-987654321",
  "property_id": "prop-123456789",
  "category": "Residential",
  "type": "Apartment",
  "name": "Unit 12B",
  "abbreviation": "U12B",
  "address_1": "456 Elm Street"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.propexo.com/v1/units/propertyware/");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"integration_id\": \"intg-987654321\",\n  \"property_id\": \"prop-123456789\",\n  \"category\": \"Residential\",\n  \"type\": \"Apartment\",\n  \"name\": \"Unit 12B\",\n  \"abbreviation\": \"U12B\",\n  \"address_1\": \"456 Elm Street\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "integration_id": "intg-987654321",
  "property_id": "prop-123456789",
  "category": "Residential",
  "type": "Apartment",
  "name": "Unit 12B",
  "abbreviation": "U12B",
  "address_1": "456 Elm Street"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.propexo.com/v1/units/propertyware/")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```